// AntStatStatic.cpp : implementation file
//

#include "stdafx.h"
#include "AntWar.h"
#include "AntStatStatic.h"
#include "MyreKrig/MyreKrig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" COLORREF *SystemColors;

/////////////////////////////////////////////////////////////////////////////
// CAntStatStatic

CAntStatStatic::CAntStatStatic()
{
	nTurnsPerPixel=1;
	pHistory=NULL;
}

CAntStatStatic::~CAntStatStatic()
{
	delete [] pHistory;
}


BEGIN_MESSAGE_MAP(CAntStatStatic, CStatic)
	//{{AFX_MSG_MAP(CAntStatStatic)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAntStatStatic message handlers

void CAntStatStatic::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	unsigned int i;
	int nWinNumPoints;
	int nY;

	CRect ClientRect;
	GetClientRect(&ClientRect);

	CBitmap MemBitMap;

	if(!pHistory)
	{
		nWidth=ClientRect.Width();
		nHeight=ClientRect.Height();
		pHistory=new COLORREF[nWidth*nHeight];
		nXPos=0;
		memset(pHistory,0,nWidth*nHeight*sizeof(COLORREF));
		nTurnsPerPixel=1;
	}

	if((CurrentTurn%nTurnsPerPixel)!=0) return;

	nWinNumPoints=nTotalAnts+nTotalBases*(NewBaseAnts+NewBaseFood);

	if(CurrentTurn>Used.HalfTimeTurn) nWinNumPoints*=Used.HalfTimePercent;
	else nWinNumPoints*=Used.WinPercent;

	nWinNumPoints/=100;

	if(nWinNumPoints==0) return;

	for (i=0;i<Used.BattleSize;i++)
	{
		nY=((TeamDatas[BattleTeams[i]].NumAnts+TeamDatas[BattleTeams[i]].NumBases*BaseValue)*nHeight)/nWinNumPoints;
		if(nY>=nHeight) nY=nHeight-1;
		pHistory[nXPos+((nHeight-nY-1)*nWidth)]=SystemColors[10+(i*3)];
	}

	if(++nXPos==ClientRect.Width()) TruncateHistory();

	MemBitMap.CreateDiscardableBitmap(&dc,nWidth,nHeight);
	MemBitMap.SetBitmapBits(sizeof(COLORREF)*nWidth*nHeight,pHistory);

	dc.DrawState(CPoint(0,0),CSize(nWidth,nHeight),&MemBitMap,DST_BITMAP);
}

void CAntStatStatic::SetStatParms(int nAnts,int nBases,int nTerritory)
{
	nTotalAnts=nAnts;
	nTotalBases=nBases;
	nTotalTerritory=nTerritory;
}

void CAntStatStatic::TruncateHistory()
{
	int nX;
	int nY;
	nXPos/=2;
	nTurnsPerPixel*=2;

	for(nY=0;nY<nHeight;nY++)
	{
		for(nX=0;nX<nXPos;nX++)
		{
			pHistory[nX+nY*nWidth]=pHistory[nX*2+nY*nWidth];
		}
		for(;nX<nWidth;nX++)
		{
			pHistory[nX+nY*nWidth]=COLORREF(0x00000000);
		}
	}
}

void CAntStatStatic::ClearStats()
{
	delete [] pHistory;
	pHistory=NULL;
}
