// AntStatic.cpp : implementation file
//

#include "stdafx.h"
#include "AntWar.h"
#include "AntStatic.h"
#include "MyreKrig/MyreKrig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" COLORREF *GraphicBuffer;
extern "C" CRITICAL_SECTION CriticalAnt;
/////////////////////////////////////////////////////////////////////////////
// CAntStatic
CAntStatic::CAntStatic()
{
}

CAntStatic::~CAntStatic()
{
}


BEGIN_MESSAGE_MAP(CAntStatic, CStatic)
	//{{AFX_MSG_MAP(CAntStatic)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CAntStatic message handlers

void CAntStatic::OnPaint() 
{
	DrawMap();
}

LRESULT CAntStatic::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	static int nCallCount=0;
	if(message==WM_USER)
	{
		if(nCallCount++>m_nUpdateRate)
		{
			nCallCount=0;
			DrawMap();
		}
	}
	return CStatic::WindowProc(message, wParam, lParam);
}

void CAntStatic::DrawMap()
{
	CBitmap MemBitMap;

	CDC *pDC=GetDC();
	clock_t nTime=-clock();

	EnterCriticalSection(&CriticalAnt);
	MemBitMap.CreateDiscardableBitmap(pDC,Used.MapWidth,Used.MapHeight);
	MemBitMap.SetBitmapBits(sizeof(COLORREF)*Used.MapWidth*Used.MapHeight,GraphicBuffer);
	pDC->DrawState(CPoint(0,0),CSize(Used.MapWidth,Used.MapHeight),&MemBitMap,DST_BITMAP);
	LeaveCriticalSection(&CriticalAnt);

	nTime+=clock();
	ReleaseDC(pDC);

	SetUpdateRate(nTime);
}

void CAntStatic::SetUpdateRate(int nClockCycles)
{
	m_nUpdateRate=nClockCycles/25;
}

