// AntWarDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AntWar.h"
#include "Myrekrig/MyreKrig.h"
#include "AntWarDlg.h"
#include "MainThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" SystemReply;
extern "C" HWND hwndMainDlg;
extern "C" COLORREF** ppTeamIcons;
extern "C" COLORREF* GraphicBuffer;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAntWarDlg dialog

CAntWarDlg::CAntWarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAntWarDlg::IDD, pParent), pImageList(0)
{
	//{{AFX_DATA_INIT(CAntWarDlg)
	m_stdout = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	pMainThread=NULL;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAntWarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAntWarDlg)
	DDX_Control(pDX, IDC_STATSTATIC, m_AntStatStatic);
	DDX_Control(pDX, IDC_EDITSTDOUT, m_stdoutCtrl);
	DDX_Control(pDX, IDC_LISTTEAMSCTRL, m_TeamListCtrl);
	DDX_Control(pDX, IDC_ANTSTATIC, m_AntStatic);
	DDX_Text(pDX, IDC_EDITSTDOUT, m_stdout);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAntWarDlg, CDialog)
	//{{AFX_MSG_MAP(CAntWarDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_NOTIFY(LVN_KEYDOWN, IDC_LISTTEAMSCTRL, OnKeydownListteamsctrl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAntWarDlg message handlers

BOOL CAntWarDlg::OnInitDialog()
{
	// Win auto code...
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	hwndMainDlg=m_hWnd;

	BattleCount = 0xffff; /* After this write, BattleCount is only written by MainThread and read from by us */

	pMainThread=new CMainThread;
	pMainThread->CommandLine=GetCommandLine();
	pMainThread->CreateThread();
//	pMainThread->SetThreadPriority(THREAD_PRIORITY_BELOW_NORMAL);
//	AfxGetApp()->SetThreadPriority(THREAD_PRIORITY_NORMAL);
	pMainThread->PostThreadMessage(WM_USER,0,0); // Start Thread (ugly as shit...)

	// Setup Fonts and ListView while waiting for thread startup...
	stdoutFont.CreatePointFont(8,"Courier",NULL); // Font stuff...
	m_stdoutCtrl.SetFont(&stdoutFont);

	m_TeamListCtrl.InsertColumn(0,"Team Name",LVCFMT_LEFT,92);
	m_TeamListCtrl.InsertColumn(1,"Bases",LVCFMT_LEFT,64);
	m_TeamListCtrl.InsertColumn(2,"Ants",LVCFMT_LEFT,80);
	m_TeamListCtrl.InsertColumn(3,"Territory",LVCFMT_LEFT,96);

	while(BattleCount==0xffff) Sleep(10); // Waiting for game to be inited...

	return TRUE;
}


void CAntWarDlg::OnPaint() 
{
	CRect ClientRect;
	CRect DesktopRect;
	CRect AntRect;
	int cxIcon = GetSystemMetrics(SM_CXICON);
	int cyIcon = GetSystemMetrics(SM_CYICON);
	int x = (ClientRect.Width() - cxIcon + 1) / 2;
	int y = (ClientRect.Height() - cyIcon + 1) / 2;
	int nMaxcx;
	const int nBorder=8;
	const int nstdoutcx=80*8+16;
	const int nListCtrlcx=338;
	const int nNumstdoutlines=24;

	int nStatscy;
	int nListCtrlcy=22+(Used.BattleSize+1)*17;

	GetDesktopWindow()->GetClientRect(&DesktopRect);

	if (IsIconic())
	{
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// Position all windows correctly - done here, since we have no messages to tell us when a new game is active
		m_AntStatic.GetWindowRect(&AntRect);

		nMaxcx=Used.MapWidth+nBorder+nListCtrlcx;
		if(nstdoutcx>nMaxcx) nMaxcx=nstdoutcx;
		nMaxcx+=2*nBorder; // Add window borders

		if((AntRect.Width()!=(signed int)(Used.MapWidth))||(AntRect.Height()!=(signed int)Used.MapHeight))
		{
			m_AntStatic.SetWindowPos(&wndTop,nBorder,nBorder,Used.MapWidth,Used.MapHeight,SWP_NOOWNERZORDER|SWP_NOZORDER);
			x=Used.MapWidth+2*nBorder;
			m_TeamListCtrl.SetWindowPos(&wndTop,x,nBorder,nListCtrlcx,nListCtrlcy,SWP_SHOWWINDOW);
			y=Used.MapHeight+2*nBorder;
			nStatscy=y-nListCtrlcy-3*nBorder;
			if(nStatscy>16) // Minimum stat size
			{
				m_AntStatStatic.SetWindowPos(&wndTop,x,nListCtrlcy+2*nBorder,nListCtrlcx,nStatscy,SWP_NOOWNERZORDER|SWP_NOZORDER);
			}
			m_stdoutCtrl.SetWindowPos(&wndTop,nBorder,y,nMaxcx-2*nBorder,nNumstdoutlines*9,SWP_NOOWNERZORDER|SWP_NOZORDER);
			y+=nNumstdoutlines*9+nBorder+24;
			
			SetWindowPos(&wndTop,(DesktopRect.Width()-nMaxcx)/2,(DesktopRect.Height()-y)/2,nMaxcx,y,SWP_SHOWWINDOW);
		}

		m_AntStatic.Invalidate(false);

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAntWarDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CAntWarDlg::DestroyWindow() 
{
	delete pMainThread;
	delete pImageList;
	return CDialog::DestroyWindow();
}

LRESULT CAntWarDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{	// No - this is not pretty...
		case WM_USER: // Draw Control
			::SendMessage(m_AntStatic.m_hWnd,message,wParam,lParam);
			UpdateTeamInfo();
			UpdateGameInfo();
			break;
		case (WM_USER+1): // New game started
			Displaystdout();
			m_AntStatStatic.ClearStats();
			FillTeams();
			break;
		case (WM_USER+2): // Quit
			PostQuitMessage(0);
			break;
	} 	
	return CDialog::WindowProc(message, wParam, lParam);
}

void CAntWarDlg::OnClose() 
{
	SystemReply=3;
	CDialog::OnClose();
}

void CAntWarDlg::UpdateTeamInfo()
{
	CString ItemText;
	unsigned int i;

	int nTotalBases=0;
	int nTotalAnts=0;
	int nTotalTerritory=0;

	for(i=0;i<Used.BattleSize;i++)
	{
		nTotalBases+=TeamDatas[BattleTeams[i]].NumBases;
		nTotalAnts+=TeamDatas[BattleTeams[i]].NumAnts;
		nTotalTerritory+=TeamDatas[BattleTeams[i]].SquareOwn;
	}

	for(i=0;i<Used.BattleSize;i++)
	{
		ItemText.Format("%d (%4.1f%%)",TeamDatas[BattleTeams[i]].NumBases,100*(double)TeamDatas[BattleTeams[i]].NumBases/nTotalBases);
		m_TeamListCtrl.SetItemText(i,1,ItemText);
		ItemText.Format("%d (%4.1f%%)",TeamDatas[BattleTeams[i]].NumAnts,100*(double)TeamDatas[BattleTeams[i]].NumAnts/nTotalAnts);
		m_TeamListCtrl.SetItemText(i,2,ItemText);
		ItemText.Format("%d (%4.1f%%)",TeamDatas[BattleTeams[i]].SquareOwn,100*(double)TeamDatas[BattleTeams[i]].SquareOwn/nTotalTerritory);
		m_TeamListCtrl.SetItemText(i,3,ItemText);
	}

	ItemText.Format("%d",nTotalBases);
	m_TeamListCtrl.SetItemText(i,1,ItemText);
	ItemText.Format("%d",nTotalAnts);
	m_TeamListCtrl.SetItemText(i,2,ItemText);
	ItemText.Format("%d (%4.1f%%)",nTotalTerritory,100*(double)nTotalTerritory/(Used.MapHeight*Used.MapWidth));
	m_TeamListCtrl.SetItemText(i,3,ItemText);		

	m_AntStatStatic.SetStatParms(nTotalAnts,nTotalBases,nTotalTerritory);
	m_AntStatStatic.RedrawWindow();
}

void CAntWarDlg::UpdateGameInfo()
{
	CString WindowText;

	WindowText.Format("AntWar - Game#%d/%d Turn#%d",BattleCount+1,Args.NumBattles,CurrentTurn);
	SetWindowText(WindowText);
}

void CAntWarDlg::OnKeydownListteamsctrl(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDown = (LV_KEYDOWN*)pNMHDR;

	*pResult=0;

	switch(pLVKeyDown->wVKey)
	{
		case VK_F1: 
			SystemReply=1;
			break;
		case VK_F2:
			SystemReply=2;
			break;
		case VK_F3:
			SystemReply=3;
			PostQuitMessage(0);
			break;
		case VK_F4:
			SystemReply=4;
			break;
		case VK_F5:
			SystemReply=5;
			break;
	}

}

void CAntWarDlg::Displaystdout()
{
	char Temp[81];
	m_stdout.Empty();
	fseek(stdout,0,SEEK_SET);
	while(fgets(Temp,81,stdout))
	{
		if(strlen(Temp))
		{
			Temp[strlen(Temp)-1]='\0';
			m_stdout+=Temp;
			m_stdout+="\r\n";
		}
	}
	UpdateData(false);
	m_stdoutCtrl.LineScroll(m_stdoutCtrl.GetLineCount());
}

void CAntWarDlg::FillTeams()
{
	m_TeamListCtrl.DeleteAllItems();

	delete pImageList;
	pImageList=new CImageList;
	pImageList->Create(16,16,ILC_COLOR32,0,1);
	CBitmap Bitmap;

	// Create images
	for(unsigned int i=0;i<=Used.BattleSize;i++) // MN: Last Bitmap is Totals"
	{
		Bitmap.CreateBitmap(16,16,1,32,ppTeamIcons[i]);
		pImageList->Add(&Bitmap,COLORREF(0));
		Bitmap.DeleteObject();
	}

	m_TeamListCtrl.SetImageList(pImageList,LVSIL_SMALL);

	// Fill listview view TeamData
	for(i=0;i<Used.BattleSize;i++)
	{
		m_TeamListCtrl.InsertItem(i,TeamDatas[BattleTeams[i]].Title,i);
	}

	m_TeamListCtrl.InsertItem(i,"Totals",i);
}
