#include <Myrekrig/Myre.h>
#include <Myrekrig/MyreKrig.h>
#include <windows.h>

HWND hwndMainDlg;
COLORREF *SystemColors=0;
static int AntColors[8] = {0x00f,0x0a0,0xf33,0x07d,0xbb0,0x80e,0xf0a,0x0dd}; // GRB
COLORREF *GraphicBuffer;
COLORREF GetColorFromSquareData(struct SquareData *pSquare);
static int nShowTerritories=1;
COLORREF **ppTeamIcons;

CRITICAL_SECTION CriticalAnt;

int SystemReply=0;
	// 0: Do nothing	
	// 1: Drop current match and start new (game not saved)
	// 2: Stop current match and start new
	// 3: Drop current match and quit entire game
	// 4: Restart current match
	// 5: Toggle between game (current/current) and (current/totalt)

bool SysGameInit(int argc, char *argv[])
{
	InitializeCriticalSection(&CriticalAnt);
	GraphicBuffer=0;
	return true;
}

bool SysBattleInit()
{
	char AntTemplate[16*16]=
	{
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		0x01,0x00,0x01,0x01,0x01,0x00,0x00,0x01,0x01,0x01,0x00,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x00,0x01,0x01,0x01,0x01,0x00,0x01,0x01,0x00,0x01,0x01,0x01,0x00,0x01,
		0x01,0x01,0x01,0x00,0x00,0x00,0x01,0x01,0x00,0x01,0x01,0x00,0x01,0x00,0x01,0x01,
		0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x01,0x01,0x01,
		0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x00,0x00,0x00,0x00,0x01,0x01,0x01,
		0x01,0x01,0x01,0x00,0x00,0x00,0x01,0x01,0x00,0x01,0x01,0x00,0x01,0x00,0x01,0x01,
		0x01,0x01,0x00,0x01,0x01,0x01,0x01,0x00,0x01,0x01,0x00,0x01,0x01,0x01,0x00,0x01,
		0x01,0x00,0x01,0x01,0x01,0x00,0x00,0x01,0x01,0x01,0x00,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,
		0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01
	};

	int t;
	u_long col;
	int r;
	int g;
	int b;
	COLORREF color;
	unsigned int c;

	EnterCriticalSection(&CriticalAnt);
	GraphicBuffer=malloc(Used.MapWidth*Used.MapHeight*sizeof(COLORREF));
	memset(GraphicBuffer,0,Used.MapWidth*Used.MapHeight*sizeof(COLORREF));

	SystemColors = (unsigned long *)malloc((9+Used.BattleSize*3)*sizeof(unsigned long));
	ppTeamIcons=malloc((Used.BattleSize+1)*sizeof(COLORREF*));

	for(c = 0 ; c < 9+Used.BattleSize*3 ; c++)
	{
	    if(c == 0)
		{
			color=0;
		}
		else if(c <= 8)
		{
			color   = ((0x010101)*(0x27 + 0x18*c));
		}
		else
		{
			t = BattleTeams[c/3-3];
			col = TeamDatas[t].Color;
			r = (col >> 16) & 0xff;
			g = (col >>  8) & 0xff;
			b = (col >>  0) & 0xff;

			switch(c%3)
			{
				case 0: /* Dark version */
					color= ((r<<14)&(0x00ff0000)) | ((g<<6)&0x0000ff00) | ((b >> 2)&0xff);
					break;
				case 1: /* Normal version */
					color= ((r<<16)&(0x00ff0000)) | ((g<<8)&0x0000ff00) | ((b)&0xff);
					break;
				case 2: /* Light version */
					color= 0x00808080 | (((r<<15)&(0x00ff0000)) | ((g<<7)&0x0000ff00) | (b >> 1)&0xff);
					break;
			}
		}
		SystemColors[c]=color;
	}

	PostMessage(hwndMainDlg,WM_PAINT,0,0);
	PostMessage(hwndMainDlg,WM_USER+1,0,0);

	for(c=0;c<Used.BattleSize;c++)
	{
		ppTeamIcons[c]=calloc(sizeof(COLORREF),sizeof(AntTemplate));
	}
	ppTeamIcons[c]=malloc(sizeof(COLORREF)*sizeof(AntTemplate));


	for(t=0;t<sizeof(AntTemplate);t++)
	{
		if(AntTemplate[t])
		{
			for(c=0;c<Used.BattleSize;c++)
			{
				ppTeamIcons[c][t]=SystemColors[c*3+10];
			}
			ppTeamIcons[c][t]=0x00ffffff;
		}
		else
		{
			ppTeamIcons[c][t]=0x00444444;
		}
	}

	LeaveCriticalSection(&CriticalAnt);
	return true;
}

void SysBattleExit()
{
	unsigned int i;
	EnterCriticalSection(&CriticalAnt);
	free(GraphicBuffer);
	free(SystemColors);
	for(i=0;i<=Used.BattleSize;i++)
	{
		free(ppTeamIcons[i]);
	}
	free(ppTeamIcons);

	LeaveCriticalSection(&CriticalAnt);
}

void SysGameExit()
{
	SystemReply=0;
	SendMessage(hwndMainDlg,WM_USER+2,0,0);
	return;
}

int SysCheck()
{
	int nRetVal=SystemReply;
	SystemReply=0;
	return nRetVal;
}

void SysDrawMap()
{
	SendMessage(hwndMainDlg,WM_USER,0,0);
}

void SysSquareChanged(int x,int y)
{
	GraphicBuffer[y*Used.MapWidth+x]=GetColorFromSquareData(&MapData(x,y));
}

COLORREF GetColorFromSquareData(struct SquareData *pSquare)
{
  return SystemColors[(pSquare->Base ? 8 :
		    pSquare->NumAnts ? TeamIndex[pSquare->Team]*3+(pSquare->NumFood ? 11 : 10) :
		    nShowTerritories && pSquare->Team && !pSquare->NumFood ? TeamIndex[pSquare->Team]*3+9 :
		    pSquare->NumFood < 29 ? (pSquare->NumFood+3)/4 : 8)];
}
